{% extends 'base.html' %}
{% block head %}
  <link rel="stylesheet" href="{{ url_for('static', filename='css/mermaid.min.css') }}">
{% endblock %}

{% block content %}

    {% with active_nav='channel' %}
        {% include "widgets/navtabs.html" %}
    {% endwith %}
<div class="pure-g">
  <div class="pure-u-1 pure-u-md-2-24"></div>
  <div class="pure-u-1 pure-u-md-20-24">

                  <div class="pure-g">
                    <div class="pure-u-1-3">
                    </div>
                    <div class="pure-u-1-3" style="text-align:center;">
                        <a class="pure-menu-heading selected">
                        {% if data == 'data_deleted' %}
                        <span style="color: red; ">
                            <b>{{ gettext('Table Deleted') }}</b></a>
                        {% else %}
                        <b>{{ gettext('Table All') }}</b></a>
                        {% endif %}
                    </div>
                    <div class="pure-u-1-3">
                    </div>
                  </div>

<p></p>

    <div>
      <div id="table"></div>
    </div>
  <script src="{{ url_for('static', filename='js/gridjs.umd.js') }}"></script>
    <script>
      const tableDiv = document.getElementById('table');

      const updateUrl = (prev, query) => {
        return prev + (prev.indexOf('?') >= 0 ? '&' : '?') + new URLSearchParams(query).toString();
      };

      const editableCellAttributes = (data, row, col) => {
          if (row) {
            return {contentEditable: 'true', 'data-element-id': row.cells[0].data};
          }
          else {
            return {};
          }
      };

      new gridjs.Grid({
        columns: [
          { id: 'id', 'hidden': true },
          { id: 'ytc_id', 'hidden': true },
          { id: 'ytc_title', name: 'Channel', sort: false, formatter: (cell, row) => {
            return gridjs.html('<a href="{{ url_for('channel.index') }}' + row.cells[1].data + '" target="_blank">' + cell + '</a>');
          }},
          { id: 'ytc_videocount', name: 'YT', width: '6%' },
          { id: 'total', name: 'T', width: '6%' },
          { id: 'archived', name: 'A', width: '6%' },
          { id: 'limited', name: 'C', width: '6%' },
          { id: 'newest', name: 'Newest', width: '9%' },
          { id: 'updated', name: 'Updated', width: '9%' },
          { id: 'delta', name:  '\u0394', 'attributes': editableCellAttributes, width: '6%' },
          { id: 'allow', name: 'E', 'attributes': editableCellAttributes, width: '5%' },
          { id: 'ytc_archive', name: 'AF', 'attributes': editableCellAttributes, width: '6%' },
          { id: 'ytc_partarchive', name: 'AP', 'attributes': editableCellAttributes, width: '6%' },
          { id: 'was_full', name: 'WF', width: '6%' },
          { id: 'was_part', name: 'WP', width: '6%' },
        ],
        search: {
          enabled: true,
          server: {
            url: (prev, search) => {
              return updateUrl(prev, {search});
            },
          },
        },
        server: {
          url: '{{ url_for('admin.channel_table_new_data') }}',
          then: results => results.data,
          total: results => results.total,
        },
        sort: {
          enabled: true,
          multiColumn: true,
          server: {
            url: (prev, columns) => {
              const columnIds = ['id', 'ytc_id', 'ytc_title', 'ytc_videocount', 'total', 'archived', 'limited', 'newest',
                 'updated', 'delta', 'allow', 'ytc_archive', 'ytc_partarchive', 'was_full', 'was_part'];
              const sort = columns.map(col => (col.direction === 1 ? '+' : '-') + columnIds[col.index]);
              return updateUrl(prev, {sort});
            },
          },
        },
        pagination: {
          enabled: true,
          limit: 50,
          server: {
            url: (prev, page, limit) => {
              return updateUrl(prev, {start: page * limit, length: limit});
            },
          },
        },
      }).render(tableDiv);

      let savedValue;

      tableDiv.addEventListener('focusin', ev => {
        if (ev.target.tagName === 'TD') {
          savedValue = ev.target.textContent;
        }
      });

      tableDiv.addEventListener('focusout', ev => {
        if (ev.target.tagName === 'TD') {
          if (savedValue !== ev.target.textContent) {
            fetch('{{ url_for('admin.channel_table_new_data') }}', {
              method: 'POST',
              headers: {'Content-Type': 'application/json'},
              body: JSON.stringify({
                id: ev.target.dataset.elementId,
                [ev.target.dataset.columnId]: ev.target.textContent
              }),
            });
          }
          savedValue = undefined;
        }
      });

      tableDiv.addEventListener('keydown', ev => {
        if (ev.target.tagName === 'TD') {
          if (ev.key === 'Escape') {
            ev.target.textContent = savedValue;
            ev.target.blur();
          }
          else if (ev.key === 'Enter') {
            ev.preventDefault();
            ev.target.blur();
          }
        }
      });
    </script>

{% endblock %}